local E, L, V, P, G, _ = unpack(ElvUI); --Inport: Engine, Locales, PrivateDB, ProfileDB, GlobalDB, Localize Underscore
local Tuk = E:GetModule("Tuk_Style")
local locale = GetLocale()

--GLOBALS: ElvUIParent
local _G = _G
local twipe, format = table.wipe, format
local GetCVarBool, StopMusic, ReloadUI = GetCVarBool, StopMusic, ReloadUI

local function SetupLayout()
	-- General
	E.db.general.minimap.size = 160

	-- Datatexts
	E.db.datatexts.font = 'ElvUI Font'
	E.db.datatexts.fontOutline = 'OUTLINE'
	E.db.datatexts.fontSize = 12

	-- Unitframes
	twipe(E.db.unitframe.units.player)
	E:CopyTable(E.db.unitframe.units.player, P.unitframe.units.player)
	twipe(E.db.unitframe.units.target)
	E:CopyTable(E.db.unitframe.units.target, P.unitframe.units.target)
	twipe(E.db.unitframe.units.targettarget)
	E:CopyTable(E.db.unitframe.units.targettarget, P.unitframe.units.targettarget)

	E.db.unitframe.fontSize = 17
	if locale == "ruRU" then
		E.db.unitframe.font = "ElvUI Font"
	else
		E.db.unitframe.font = "TukUI Unitframes"
	end
	E.db.unitframe.fontOutline = "OUTLINE"
	E.db.unitframe.colors.healthclass = true
	E.db.unitframe.colors.transparentHealth = true

	E.db.unitframe.units.player.health.attachTextTo = "InfoPanel"
	E.db.unitframe.units.player.power.attachTextTo = "InfoPanel"
	E.db.unitframe.units.player.debuffs.fontSize = 14
	E.db.unitframe.units.player.buffs.fontSize = 14
	E.db.unitframe.units.player.infoPanel.enable = true

	E.db.unitframe.units.target.name.position = "LEFT"
	E.db.unitframe.units.target.name.attachTextTo = "InfoPanel"
	E.db.unitframe.units.target.health.attachTextTo = "InfoPanel"
	E.db.unitframe.units.target.name.text_format = "[powercolor][power:current]  [namecolor][name:medium] [difficultycolor][smartlevel] [shortclassification]"
	E.db.unitframe.units.target.power.text_format = ""
	E.db.unitframe.units.target.debuffs.fontSize = 14
	E.db.unitframe.units.target.buffs.fontSize = 14
	E.db.unitframe.units.target.infoPanel.enable = true

	E.db.unitframe.units.targettarget.power.height = 5
	E.db.unitframe.units.targettarget.height = 40
	-- E.db.unitframe.units.targettarget.name.yOffset = -37
	E.db.unitframe.units.targettarget.infoPanel.enable = true
	E.db.unitframe.units.targettarget.name.attachTextTo = "InfoPanel"


	E.db.unitframe.units.party.infoPanel.enable = true
	E.db.unitframe.units.party.health.attachTextTo = "InfoPanel"
	E.db.unitframe.units.party.power.attachTextTo = "InfoPanel"
	E.db.unitframe.units.party.name.attachTextTo = "InfoPanel"
	
	E.db.unitframe.units.raid.infoPanel.enable = true
	E.db.unitframe.units.raid.health.attachTextTo = "InfoPanel"
	E.db.unitframe.units.raid.power.attachTextTo = "InfoPanel"
	E.db.unitframe.units.raid.name.attachTextTo = "InfoPanel"

	-- Actionbars
	E.db.actionbar.font = "TukUI Actionbars"
	E.db.actionbar.fontSize = 11
	E.db.actionbar.fontOutline = "OUTLINE"

	-- Auras
	E.db.auras.font = "TukUI Actionbars"
	E.db.auras.fontOutline = "OUTLINE"
	E.db.auras.fontSize = 10
	E.db.auras.buffs.horizontalSpacing = 4
	E.db.auras.buffs.size = 28
	E.db.auras.debuffs.size = 30

	-- movers
	Tuk:SetMoverPosition('ElvUF_PlayerMover', 'BOTTOM', ElvUIParent, 'BOTTOM', -280, 175)
	Tuk:SetMoverPosition('ElvUF_TargetMover', 'BOTTOM', ElvUIParent, 'BOTTOM', 280, 175)
	Tuk:SetMoverPosition('ElvUF_TargetTargetMover', 'BOTTOM', ElvUIParent, 'BOTTOM', 0, 157)
	Tuk:SetMoverPosition('ElvUF_PetMover', 'BOTTOM', ElvUIParent, 'BOTTOM', 0, 238)
	Tuk:SetMoverPosition('BossButton', 'BOTTOM', ElvUIParent, 'BOTTOM', 0, 343)
	Tuk:SetMoverPosition('MinimapMover', 'TOPRIGHT', ElvUIParent, 'TOPRIGHT', -21, -16)
	Tuk:SetMoverPosition('BuffsMover', 'TOPRIGHT', ElvUIParent, 'TOPRIGHT', -189, -16)
	Tuk:SetMoverPosition('DebuffsMover', 'TOPRIGHT', ElvUIParent, 'TOPRIGHT', -189, -157)

	_G["PluginInstallStepComplete"].message = L['Layout Set']
	_G["PluginInstallStepComplete"]:Show()
	E:UpdateAll(true)
end

local function InstallComplete()
	E.private.install_complete = E.version
	E.private.tukui_installed = true

	if GetCVarBool('Sound_EnableMusic') then
		StopMusic()
	end

	ReloadUI()
end

Tuk.InstallTable = {
	["Name"] = "|cffff8000Tukui Style|r",
	["Title"] = "|cffff8000Tukui Style|r",
	["tutorialImage"] = [[Interface\AddOns\ElvUI_TukUIStyle\media\textures\logo.blp]],
	["Pages"] = {
		[1] = function()
			_G["PluginInstallFrame"].SubTitle:SetText(format(L['Welcome to Tukui Style version %s, for ElvUI %s.'], Tuk.Version, E.version))
			_G["PluginInstallFrame"].Desc1:SetText(L["By pressing the Continue button, Tukui Style will be applied in your current ElvUI installation."])
			_G["PluginInstallFrame"].Desc2:SetText(L['Please press the continue button to go onto the next step.'])

			_G["PluginInstallFrame"].Option1:Show()
			_G["PluginInstallFrame"].Option1:SetScript('OnClick', InstallComplete)
			_G["PluginInstallFrame"].Option1:SetText(L['Skip Process'])
		end,
		[2] = function()
			_G["PluginInstallFrame"].SubTitle:SetText(L['Tukui Style Layout'])
			_G["PluginInstallFrame"].Desc1:SetText(L['This part of the installation changes the default ElvUI look. Doing this will also reset settings for some of your unitframe to default.'])
			_G["PluginInstallFrame"].Desc2:SetText(L['Please click the button below to apply the new layout.'])
			_G["PluginInstallFrame"].Desc3:SetText(L['Importance: |cff07D400High|r'])

			_G["PluginInstallFrame"].Option1:Show()
			_G["PluginInstallFrame"].Option1:SetScript('OnClick', SetupLayout)
			_G["PluginInstallFrame"].Option1:SetText(L['Setup Layout'])
		end,
		[3] = function()
			_G["PluginInstallFrame"].SubTitle:SetText(L['Installation Complete'])
			_G["PluginInstallFrame"].Desc1:SetText(L['You are now finished with the installation process. If you are in need of technical support please visit us at http://www.tukui.org.'])
			_G["PluginInstallFrame"].Desc2:SetText(L['Please click the button below so you can setup variables and ReloadUI.'])

			_G["PluginInstallFrame"].Option1:Show()
			_G["PluginInstallFrame"].Option1:SetScript('OnClick', InstallComplete)
			_G["PluginInstallFrame"].Option1:SetText(L['Finished'])
		end,
	},
}