local E, L, V, P, G = unpack(ElvUI)
local Tuk = E:GetModule("Tuk_Style")
--GLOBALS: CreateFrame
local _G = _G
local ToggleFrame, ToggleCharacter = ToggleFrame, ToggleCharacter

function Tuk:CreatePanels()
	local BottomLine = CreateFrame("Frame", nil, E.UIParent)
	BottomLine:SetTemplate("Default")
	BottomLine:Size(2)
	BottomLine:Point("BOTTOMLEFT", 30, 30)
	BottomLine:Point("BOTTOMRIGHT", -30, 30)
	BottomLine:SetFrameStrata("BACKGROUND")
	BottomLine:SetFrameLevel(0)

	local LeftVerticalLine = CreateFrame("Frame", nil, BottomLine)
	LeftVerticalLine:SetTemplate("Default")
	LeftVerticalLine:Point("BOTTOMLEFT", 0, 0)
	LeftVerticalLine:SetFrameLevel(0)
	LeftVerticalLine:SetFrameStrata("BACKGROUND")
	LeftVerticalLine:SetAlpha(1)

	local RightVerticalLine = CreateFrame("Frame", nil, BottomLine)
	RightVerticalLine:SetTemplate("Default")
	RightVerticalLine:Point("BOTTOMRIGHT", 0, 0)
	RightVerticalLine:SetFrameLevel(0)
	RightVerticalLine:SetFrameStrata("BACKGROUND")
	RightVerticalLine:SetAlpha(1)

	local CubeLeft = CreateFrame("Frame", nil, LeftVerticalLine)
	CubeLeft:SetTemplate("Default")
	CubeLeft:Size(10)
	CubeLeft:Point("BOTTOM", LeftVerticalLine, "TOP", 0, 0)
	CubeLeft:EnableMouse(true)
	CubeLeft:SetFrameLevel(0)
	CubeLeft:SetScript("OnMouseDown", function(self, Button)
		if (Button == "LeftButton") then
			ToggleFrame(_G["ChatMenu"])
		end
	end)

	local CubeRight = CreateFrame("Frame", nil, RightVerticalLine)
	CubeRight:SetTemplate("Default")
	CubeRight:Size(10)
	CubeRight:Point("BOTTOM", RightVerticalLine, "TOP", 0, 0)
	CubeRight:EnableMouse(true)
	CubeRight:SetFrameLevel(0)
	CubeRight:SetScript("OnMouseDown", function(self, Button)
		if (Button == "LeftButton") then
			ToggleCharacter("ReputationFrame")
		end
	end)

	self.BottomLine = BottomLine
	self.LeftVerticalLine = LeftVerticalLine
	self.RightVerticalLine = RightVerticalLine
	self.CubeLeft = CubeLeft
	self.CubeRight = CubeRight
end

function Tuk:SizePanels()
	Tuk.LeftVerticalLine:Size(2, E.db.chat.panelHeight - 40)
	Tuk.RightVerticalLine:Size(2, (E.db.chat.separateSizes and E.db.chat.panelHeightRight or E.db.chat.panelHeight) - 40)
	_G["ElvUI_ExperienceBar"]:Size(10, E.db.chat.panelHeight - 50)
	_G["ElvUI_ExperienceBar"]:Point("TOP", Tuk.LeftVerticalLine, "TOP", 0, -4)
	_G["ElvUI_ReputationBar"]:Size(10, (E.db.chat.separateSizes and E.db.chat.panelHeightRight or E.db.chat.panelHeight) - 50)
	_G["ElvUI_ReputationBar"]:Point("TOP", Tuk.RightVerticalLine, "TOP", 0, -4)
end

function Tuk:RepositionExpRep()
	_G["ElvUI_ExperienceBar"]:ClearAllPoints()
	_G["ElvUI_ReputationBar"]:ClearAllPoints()

	_G["ElvUI_ExperienceBar"]:SetTemplate("Default")
	_G["ElvUI_ReputationBar"]:SetTemplate("Default")
end